'Compilable Example:
#Compile Exe "gbplayer.exe"
#Dim All

%Unicode = 1
#Include "win32api.inc"
#Include "mmdeviceapi.inc"      ' -- Headers with COM classes declarations,
#Include "endpointvolume.inc"   ' -- translated from Windows Platform SDK by Jos Roca
#Include Once "files\gbCAfxMp3.inc"

#Resource Manifest, 1, "files\xptheme.xml"

#Resource Icon logo "icons\gbplayer.ico"
#Resource Icon xsoundblock "icons\sound.ico"
#Resource Icon xsoundplus "icons\plus.ico"
#Resource Icon xsoundminus "icons\minus.ico"
#Resource Icon xplay "icons\play.ico"
#Resource Icon xstop "icons\stop.ico"
#Resource Icon xnext "icons\next.ico"
#Resource Icon xprevious "icons\previous.ico"
#Resource Icon xhelp "icons\help.ico"
#Resource Icon xup "icons\sortascending.ico"
#Resource Icon xdown "icons\sortdescending.ico"
#Resource Icon xremove "icons\remove.ico"
#Resource Icon xpause "icons\pause.ico"
#Resource Icon xsettings "icons\settings.ico"
#Resource Icon xloop "icons\loop.ico"

$Ver = "1.41"
%WM_GraphNotify = %WM_User + 500

Enum Equates Singular
   IDC_StatusBar = 500
   IDC_Toolbar
   IDC_ListView

   IDT_Play
   IDT_SoundBlock
   IDT_SoundPlus
   IDT_SoundMinus
   IDT_Pause
   IDT_Stop
   IDT_Remove
   IDT_Next
   IDT_Previous
   IDT_AutoLoop
   IDT_Settings
   IDT_Help

   ID_Timer
   IDM_Open
   IDM_Play
   IDM_Stop
   IDM_Next
   IDM_Pause
   IDM_Previous
   IDM_CheckAll
   IDM_UnCheckAll
   IDM_RemoveAll
   IDM_Remove
   IDM_MiniBar
   IDM_Reload
   IDM_Compact

   IDM_LimitVolume
   IDM_SubFolders
   IDM_AutoPlay      'on start, on drop
   IDM_AutoLoop
   IDM_PlayCheckedOnly
   IDM_LoopSong
   IDM_RemoveDupes
   IDM_Sep
   IDM_GoToSelection
   IDM_GoToSongPlaying

   IDM_UseWMA
   IDM_UseWAV
   IDM_UseMP4
   IDM_UseOther
   IDM_SetOther

   IDM_OpenPlayList
   IDM_SaveAsPlayList
End Enum

Global hDlg, hToolbar, hListView, hImageList, hContext As Dword
Global hOpen, hSettings,hHeader,ghHook As Dword
Global SongCount,CurrentSong, Mute, SortDirection, MiniBar As Long
Global OtherExt, PlayList As WStringZ * %Max_Path
Global pAfxMp3 As IAfxMp3
Global LimitVolume, AutoPlay, PlayCheckedOnly, SongPlaying As Long
Global LoopSong, AutoLoop, SongLength, CurrentPos, Paused As Long
Global VolumeMixer,VolumeLimit,SubFolders, UseWMA, UseWAV, UseMP3, UseOther As Long

Function PBMain
   Dialog Font Default "Tahoma", 10, 0
   Dialog New Pixels, 0, "gbPlayer  v" + $ver, , , 200, 100, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateListView
   CreateStatusBar
   DragAcceptFiles hDlg, %True
   Dialog Show Modal hDlg, Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local PTT As TooltipText Ptr, FileCount,i,w,h As Long
   Local LVData As NM_ListView, FileName As WStringZ * %Max_Path
   Local NMTB As TBNotify Ptr, rc As Rect, pt As Point
   Local pIMediaEventEx As IMediaEventEx

   Select Case Cb.Msg
      Case %WM_InitDialog
         BuildAcceleratorTable
         settings_ini "get"
         CreateToolbar
         If IsFolder (Exe.Path$ + "playlists") = %False Then MkDir Exe.Path$ + "playlists"
         pAfxMp3 = Class "CAfxMp3"
         OpenPlayList
         AddFilesFromCommand

         ListView Get Count hDlg, %IDC_ListView To SongCount
         Statusbar Set Text hDlg, %IDC_StatusBar, 1,0,"Songs:" + Str$(SongCount)
         If (CurrentSong=0) And SongCount Then CurrentSong = 1
         ListView Select hDlg, %IDC_ListView, CurrentSong
         ListView Visible hDlg, %IDC_ListView, CurrentSong
         ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

         If Mute Then ManageVolume 0,1
         If AutoPlay Then PlayCurrentSong
         SetMenusAndToolbar

         SetTimer hDlg, %ID_Timer, 250, ByVal %Null  'used to track .Duration (time left in song)

      Case %WM_Timer
         CurrentPos = pAfxMp3.CurrentPosition / 10000000
         Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, Format$((SongLength-CurrentPos)/60,"#0") + ":" + Format$((SongLength-CurrentPos) Mod 60,"00")

      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Size hDlg, %IDC_ListView, w-10,h-85

      Case %WM_DROPFILES
         FileCount = DragQueryFile(Cb.WParam, -1, ByVal 0, 0)
         For i = 0 To FileCount-1
            DragQueryFile Cb.WParam, i, FileName, SizeOf(FileName)
            If IsFile(FileName) Then
               If InStr(FileExt,LCase$(Right$(FileName,4))) Then
                  ListView Insert Item hDlg, %IDC_ListView, 1, 0, PathName$(Namex,FileName)
                  ListView Set Text hDlg, %IDC_ListView, 1, 2, FileName
                  CurrentSong = 1
               End If
            ElseIf IsFolder(FileName) Then
               If SubFolders Then
                  AddFilesFromSubFolders((FileName),FileCount)
               Else
                  AddFilesFromFolder((FileName),FileCount)
               End If
            End If
         Next i

         ListView Get Count hDlg, %IDC_ListView To SongCount
         Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Songs:" + Str$(SongCount)
         If SongCount Then
            CurrentSong = 1
            ListView Select hDlg, %IDC_ListView, CurrentSong
            ListView Visible hDlg, %IDC_ListView, CurrentSong
            ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
            If AutoPlay Then PlayCurrentSong
         End If
         DragFinish Cb.WParam

      Case %WM_GRAPHNOTIFY
         If AutoLoop Then
            Local lEventCode, lParam1, lParam2 As Long
            pIMediaEventEx = pAfxMp3.GetIMediaEventExObject
            If IsObject(pIMediaEventEx) Then
               Do
                  pIMediaEventEx.GetEvent(lEventCode, lParam1, lParam2, 0)
                  If ObjResult <> %S_Ok Then Exit Do
                  pIMediaEventEx.FreeEventParams(lEventCode, lParam1, lParam2)
                  If lEventCode = %EC_COMPLETE Then
                     ' --- Do something, e.g.
                     If LoopSong Then
                        PlayCurrentSong
                     Else
                        If PlayCheckedOnly Then
                           PlayNextCheckedSongLooping
                        Else
                           PlayNextSongLooping
                        End If
                     End If
                     Exit Do
                  End If
               Loop
            End If
            If IsObject(pIMediaEventEx) Then pIMediaEventEx = Nothing
         End If

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdOk
               PlayCurrentSong

            Case %IDT_Pause, %IDM_Pause
               Paused = 1
               i = pAfxMp3.Pause

            Case %IDT_Stop, %IDM_Stop
               pAfxMp3.Stop
               Paused = 0

            Case %IDT_Play, %IDM_Play
               If Paused Then
                  pAfxMp3.Run
               Else
                  PlayCurrentSong
               End If
               Paused = 0

            Case %IDM_RemoveAll
               pAfxMp3.Stop
               ListView Reset hDlg, %IDC_ListView
               ListView Get Count hDlg, %IDC_ListView To SongCount
               Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Songs:" + Str$(SongCount)
               Statusbar Set Text hDlg, %IDC_StatusBar, 2,0, ""
               Statusbar Set Text hDlg, %IDC_StatusBar, 3,0, ""

            Case %IDT_Remove, %IDM_Remove
               pAfxMp3.Stop
               ListView Get Select hDlg, %IDC_ListView To CurrentSong
               If CurrentSong = 0 Then Beep : Exit Function

               ListView Delete Item hDlg, %IDC_ListView, CurrentSong
               ListView Get Count hDlg, %IDC_Listview To SongCount
               If SongCount = 0 Then Beep : Exit Function

               ListView Get Count hDlg, %IDC_ListView To SongCount
               If CurrentSong > SongCount Then CurrentSong = SongCount
               ListView Select hDlg, %IDC_ListView, CurrentSong
               ListView Visible hDlg, %IDC_ListView, CurrentSong
               ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
               Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Songs:" + Str$(SongCount)

            Case %IDT_Previous, %IDM_Previous
               If PlayCheckedOnly Then PlayPreviousCheckedSong Else PlayPreviousSong

            Case %IDT_Next, %IDM_Next
               If PlayCheckedOnly Then PlayNextCheckedSong Else PlayNextSong

            Case %IDT_SoundMinus : Mute = 0    : ManageVolume -1,0 : SetMenusAndToolbar
            Case %IDT_SoundBlock : Mute Xor= 1 : ManageVolume  0,0 : SetMenusAndToolbar
            Case %IDT_SoundPlus  : Mute = 0    : ManageVolume +1,0 : SetMenusAndToolbar

            Case %IDT_AutoLoop
               AutoLoop Xor= 1
               SetMenusAndToolbar

            Case %IDT_Settings, %IDM_MiniBar
               MiniBar Xor= 1
               CreateToolbar
               Dialog Get Size hDlg To w,h
               Dialog Set Size hDlg, IIf(MiniBar,275,645),h
               SetMenusAndToolbar

            Case %IDM_Compact
               MiniBar Xor= 1
               CreateToolbar
               If MiniBar Then
                  Dialog Set Size hDlg, 195,125
               Else
                  Dialog Set Size hDlg, 645,300
               End If
               SetMenusAndToolbar

            Case %IDT_Help
               i = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbplayer.htm", $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_CheckAll    : SelectAll(1)
            Case %IDM_UnCheckAll  : SelectAll(0)

            Case %IDM_LimitVolume
               LimitVolume Xor= 1
               ManageVolume 99,0     'just show Statusbar, don't actually change the volumne
               SetMenusAndToolbar

            Case %IDM_SubFolders
               SubFolders Xor= 1
               SetMenusAndToolbar

            Case %IDM_AutoPlay
               AutoPlay Xor= 1
               SetMenusAndToolbar

            Case %IDM_AutoLoop
               AutoLoop Xor= 1
               SetMenusAndToolbar

            Case %IDM_PlayCheckedOnly
               PlayCheckedOnly Xor= 1
               SetMenusAndToolbar

            Case %IDM_LoopSong
               LoopSong Xor= 1
               SetMenusAndToolbar

            Case %IDM_RemoveDupes : RemoveDupes

            Case %IDM_Reload
               pAfxMp3.Stop
               OpenPlayList
               ListView Get Count hDlg, %IDC_ListView To SongCount
               Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Songs:" + Str$(SongCount)
               If (CurrentSong=0) And SongCount Then CurrentSong = 1
               ListView Select hDlg, %IDC_ListView, CurrentSong
               ListView Visible hDlg, %IDC_ListView, CurrentSong
               ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
               If AutoPlay Then PlayCurrentSong

            Case %IDM_Open
               ListView Get Select hdlg, %IDC_ListView To CurrentSong
               ListView Get Text hDlg, %IDC_ListView, CurrentSong, 2 To FileName
               i = ShellExecute(hDlg, "Open", PathName$(Path,FileName), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_OpenPlayList
               SelectAndOpenPlayList
               If AutoPlay = 0 Then pAfxMp3.Stop

            Case %IDM_SaveAsPlayList
               SaveAsPlayList
               If AutoPlay = 0 Then pAfxMp3.Stop

            Case %IDM_GoToSelection
               ListView Get Select hDlg, %IDC_ListView To CurrentSong
               ListView Visible hDlg, %IDC_ListView, CurrentSong

            Case %IDM_GoToSongPlaying
               ListView Select hDlg, %IDC_ListView, SongPLaying
               ListView Visible hDlg, %IDC_ListView, SongPlaying

            Case %IDM_UseWMA
               UseWMA Xor= 1
               SetMenusAndToolbar

            Case %IDM_UseWAV
               UseWAV Xor= 1
               SetMenusAndToolbar

            Case %IDM_UseMP4
               UseMP3 Xor= 1
               SetMenusAndToolbar

            Case %IDM_UseOther
               UseOther Xor= 1
               SetMenusAndToolbar

            Case %IDM_SetOther : SetOtherExtensions

         End Select

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_Play To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_Play       : @PTT.@lpszText = "Play Selected Song"
                        Case %IDT_Stop       : @PTT.@lpszText = "Stop Playing Sond"
                        Case %IDT_Pause      : @PTT.@lpszText = "Pause Playing MP3, Stop WAV"
                        Case %IDT_Remove     : @PTT.@lpszText = "Remove Selected Song"
                        Case %IDT_Previous   : @PTT.@lpszText = "Play Previous Song"
                        Case %IDT_Next       : @PTT.@lpszText = "Play Next Song"
                        Case %IDT_SoundBlock : @PTT.@lpszText = "Mute Sound"
                        Case %IDT_SoundPlus  : @PTT.@lpszText = "Raise Sound"
                        Case %IDT_SoundMinus : @PTT.@lpszText = "Lower Sound"
                        Case %IDT_AutoLoop   : @PTT.@lpszText = IIf$(LoopSong,"Repeat Song", "Repeat List")
                        Case %IDT_Help       : @PTT.@lpszText = "Online Help"
                        Case %IDT_Settings   : @PTT.@lpszText = "Settings"
                     End Select
               End Select
            Case %IDC_StatusBar
               Select Case Cb.NmCode
                  Case %NM_Click
                     GetCursorPos pt               'pt has xy screen coordinates
                     ScreenToClient hDlg, pt       'pt now has client coordinates
                     Local a As Quad, b As Quad, s As Single
                     Dialog Get Client hDlg To w,h
                     s = pt.x / w
                     a = pAfxMp3.Duration  * s
                     b = pAfxMp3.Duration
                     pAfxMp3.SetPositions(a, b, %False)
               End Select
            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                     MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                     Select Case @nmtb.iItem
                        Case %IDT_Play
                           Call TrackPopupMenu (hOpen, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Settings
                           Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select
            Case %IDC_ListView
               Select Case Cb.NmCode
                  Case %NM_DblClk
                     ListView Get Select hDlg, %IDC_Listview To CurrentSong
                     If CurrentSong Then PlayCurrentSong
                  Case %LVN_ColumnClick
                     Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                     SortDirection = SortDirection Xor 1
                     If SortDirection Then
                        ListView Sort hDlg, %IDC_ListView, LVData.iSubItem+1, Ascend
                     Else
                        ListView Sort hDlg, %IDC_ListView, LVData.iSubItem+1, Descend
                     End If
                     SetHeaderIConsOnRight LVData.iSubItem
               End Select
         End Select

      Case %WM_ContextMenu
         TrackPopupMenu hContext, %TPM_LeftAlign, Lo(Integer,Cb.LParam), Hi(Integer, Cb.LParam), 0, hDlg, ByVal 0

      Case %WM_Destroy
         SavePlayList
         ListView Get Select hDlg, %IDC_ListView To CurrentSong
         settings_ini "save"
   End Select
End Function

Sub SetMenusAndToolbar
   'Toolbar
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SoundBlock, IIf(Mute,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_AutoLoop, IIf(AutoLoop,%TBState_Checked,0) Or %TBState_Enabled

   'Menus
    Menu Set State hSettings, ByCmd %IDM_LimitVolume,    LimitVolume * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_SubFolders,    SubFolders * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AutoPlay,    AutoPlay * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AutoLoop,    AutoLoop * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_PlayCheckedOnly,   PlayCheckedOnly  * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_LoopSong,       LoopSong * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_MiniBar,       MiniBar * %MFS_Checked Or %MFS_Enabled

    Menu Set State hOpen, ByCmd %IDM_UseWMA, UseWMA * %MFS_Checked Or %MFS_Enabled
    Menu Set State hOpen, ByCmd %IDM_UseWAV, UseWAV * %MFS_Checked Or %MFS_Enabled
    Menu Set State hOpen, ByCmd %IDM_UseMP4, UseMP3 * %MFS_Checked Or %MFS_Enabled
    Menu Set State hOpen, ByCmd %IDM_UseOther, UseOther * %MFS_Checked Or %MFS_Enabled
End Sub

Sub CreateToolbar
    Control Kill hDlg, %IDC_Toolbar

    Menu New PopUp To hOpen
    Menu Add String, hOpen, "Open Play List ...", %IDM_OpenPlayList, %MF_Enabled
    Menu Add String, hOpen, "Save As Play List ...", %IDM_SaveAsPlayList, %MF_Enabled
    Menu Add String, hOpen, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hOpen, "MP4", %IDM_UseMP4, %MF_Enabled
    Menu Add String, hOpen, "WAV", %IDM_UseWAV, %MF_Enabled
    Menu Add String, hOpen, "WMA", %IDM_UseWMA, %MF_Enabled
    Menu Add String, hOpen, "Other", %IDM_UseOther, %MF_Enabled
    Menu Add String, hOpen, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hOpen, "Set Other Extensions", %IDM_SetOther, %MF_Enabled

    Menu New PopUp To hSettings
    Menu Add String, hSettings, "AutoPlay", %IDM_AutoPlay, %MF_Enabled
    Menu Add String, hSettings, "AutoLoop", %IDM_AutoLoop, %MF_Enabled
    Menu Add String, hSettings, "Scan SubFolders on Drop", %IDM_SubFolders, %MF_Enabled
    Menu Add String, hSettings, "Play Only Checked Songs", %IDM_PlayCheckedOnly, %MF_Enabled
    Menu Add String, hSettings, "Loop Single Song", %IDM_LoopSong, %MF_Enabled
    Menu Add String, hSettings, "Limit Volume", %IDM_LimitVolume, %MF_Enabled
    Menu Add String, hSettings, "Minimal Toolbar", %IDM_MiniBar, %MF_Enabled
    Menu Add String, hSettings, "Compact Footprint", %IDM_Compact, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Go To Song Playing", %IDM_GoToSongPlaying, %MF_Enabled
    Menu Add String, hSettings, "Go To Song Selected", %IDM_GoToSelection, %MF_Enabled

    ImageList New Icon 24,24,24,15 To hImageList
    ImageList Add Icon hImageList, "xsoundminus"  '1
    ImageList Add Icon hImageList, "xsoundblock"  '2
    ImageList Add Icon hImageList, "xsoundplus"   '3
    ImageList Add Icon hImageList, "xstop"        '4
    ImageList Add Icon hImageList, "xplay"        '5
    ImageList Add Icon hImageList, "xnext"        '6
    ImageList Add Icon hImageList, "xprevious"    '7
    ImageList Add Icon hImageList, "xhelp"        '8
    ImageList Add Icon hImageList, "xremove"      '9
    ImageList Add Icon hImageList, "xpause"       '10
    ImageList Add Icon hImageList, "xsettings"    '11
    ImageList Add Icon hImageList, "xloop"        '12

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Send hDlg, %IDC_Toolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS   'allow dropdown arrow buttons
    Control Handle hDlg, %IDC_Toolbar To hToolbar

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Play, %TbStyle_DropDown, "Play"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10,  %IDT_Pause, %BTNS_Button, "Pause"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Stop, %BTNS_Button, "Stop"

    If MiniBar = 0 Then
       Toolbar Add Separator hDlg, %IDC_Toolbar, 20
       Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Remove, %BTNS_Button, "Remove"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 20
       Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_Previous, %BTNS_Button, "Prev"
       Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Next, %BTNS_Button, "Next"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 20
       Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_SoundMinus, %BTNS_Button, "Lower"
    End If

       Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_SoundBlock, %BTNS_Check, "Mute"

    If MiniBar = 0 Then
       Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_SoundPlus, %BTNS_Button, "Higher"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 20
       Toolbar Add Button    hDlg, %IDC_Toolbar, 12,  %IDT_AutoLoop, %BTNS_Check, "Loop"
    End If

    Toolbar Add Button    hDlg, %IDC_Toolbar, 11, %IDT_Settings,  %TbStyle_DropDown, "Settings"
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_Help, %BTNS_Button, "Help"
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "645", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "300", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variable
      Getprivateprofilestring "All", "PlayList", Exe.Path$ + "playlists\playlist.txt", PlayList, %Max_Path, INIFileName
      Getprivateprofilestring "All", "OtherExt", ".mid", OtherExt, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "Mute", "0", temp, %Max_Path, INIFileName:  Mute = Val(temp)
      Getprivateprofilestring "All", "CurrentSong", "0", temp, %Max_Path, INIFileName:  CurrentSong = Val(temp)
      Getprivateprofilestring "All", "LimitVolume", "0", temp, %Max_Path, INIFileName:  LimitVolume = Val(temp)
      Getprivateprofilestring "All", "SubFolders", "0", temp, %Max_Path, INIFileName:  SubFolders = Val(temp)
      Getprivateprofilestring "All", "AutoPlay", "1", temp, %Max_Path, INIFileName:  AutoPlay = Val(temp)
      Getprivateprofilestring "All", "MiniBar", "0", temp, %Max_Path, INIFileName:  MiniBar = Val(temp)
      Getprivateprofilestring "All", "AutoLoop", "1", temp, %Max_Path, INIFileName:  AutoLoop = Val(temp)
      Getprivateprofilestring "All", "PlayCheckedOnly", "0", temp, %Max_Path, INIFileName: PlayCheckedOnly  = Val(temp)
      Getprivateprofilestring "All", "LoopSong", "0", temp, %Max_Path, INIFileName: LoopSong  = Val(temp)
      Getprivateprofilestring "All", "VolumeMixer", "5", temp, %Max_Path, INIFileName: VolumeMixer  = Val(temp)
      Getprivateprofilestring "All", "VolumeLimit", "0", temp, %Max_Path, INIFileName: VolumeLimit  = Val(temp)

      Getprivateprofilestring "All", "UseMP4", "1", temp, %Max_Path, INIFileName: UseMP3  = Val(temp)
      Getprivateprofilestring "All", "UseWAV", "1", temp, %Max_Path, INIFileName: UseWAV  = Val(temp)
      Getprivateprofilestring "All", "UseWMA", "1", temp, %Max_Path, INIFileName: UseWMA  = Val(temp)
      Getprivateprofilestring "All", "UseOther", "1", temp, %Max_Path, INIFileName: UseOther  = Val(temp)

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save string variables
      WritePrivateProfileString "All", "PlayList", PlayList, INIFileName
      WritePrivateProfileString "All", "OtherExt", OtherExt, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "Mute", Str$(Mute), INIFileName
      WritePrivateProfileString "All", "CurrentSong", Str$(CurrentSong), INIFileName
      WritePrivateProfileString "All", "LimitVolume", Str$(LimitVolume), INIFileName
      WritePrivateProfileString "All", "MiniBar", Str$(MiniBar), INIFileName
      WritePrivateProfileString "All", "SubFolders", Str$(SubFolders), INIFileName
      WritePrivateProfileString "All", "AutoPlay", Str$(AutoPlay), INIFileName
      WritePrivateProfileString "All", "AutoLoop", Str$(AutoLoop), INIFileName
      WritePrivateProfileString "All", "PlayCheckedOnly", Str$(PlayCheckedOnly), INIFileName
      WritePrivateProfileString "All", "LoopSong", Str$(LoopSong), INIFileName
      WritePrivateProfileString "All", "VolumeMixer", Str$(VolumeMixer), INIFileName
      WritePrivateProfileString "All", "VolumeLimit", Str$(VolumeLimit), INIFileName

      WritePrivateProfileString "All", "UseMP4", Str$(UseMP3), INIFileName
      WritePrivateProfileString "All", "UseWAV", Str$(UseWAV), INIFileName
      WritePrivateProfileString "All", "UseWMA", Str$(UseWMA), INIFileName
      WritePrivateProfileString "All", "UseOther", Str$(UseOther), INIFileName
   End If
End Sub

Sub ManageVolume(Task As Long, Startup As Long)
    Local pIMMDeviceEnumerator  As IMMDeviceEnumerator
    Local pIMMDevice            As IMMDevice
    Local pIAudioEndpointVolume As IAudioEndpointVolume

    If LimitVolume Then
       Select Case Task
          Case -1
             If VolumeLimit = -10000 Then Beep
             VolumeLimit = Max(-10000,VolumeLimit-500)
             pAfxMp3.Volume = VolumeLimit
          Case 0
             pAfxMp3.Volume = IIf(Mute, -10000, VolumeLimit)
          Case +1
             If VolumeLimit = 0 Then Beep
             VolumeLimit = Min(0,VolumeLimit+500)
             pAfxMp3.Volume = VolumeLimit
       End Select
       Statusbar Set Text hDlg, %IDC_Statusbar, 3,0, IIf$(Mute, "Mute: On", "Volume: " + Format$(-VolumeLimit/10000, "#0"))
    Else
       pIMMDeviceEnumerator = NewCom ClsId $CLSID_MMDeviceEnumerator
       If IsObject(pIMMDeviceEnumerator) Then
           pIMMDeviceEnumerator.GetDefaultAudioEndpoint(%EDataFlow_eRender, %ERole_eMultimedia, pIMMDevice)
           If IsObject(pIMMDevice) Then
               pIMMDevice.Activate($IID_IAudioEndpointVolume, %CLSCTX_ALL, ByVal %NULL, pIAudioEndpointVolume)
               If IsObject(pIAudioEndpointVolume) Then
                   pIAudioEndpointVolume.GetMasterVolumeLevelScalar(VolumeMixer/100)

                   pIAudioEndpointVolume.SetMute(%False, ByVal %NULL)
                   Select Case Task
                      Case -1
                         If VolumeMixer = 0 Then Beep
                         VolumeMixer = Max(0,VolumeMixer-5)
                         pIAudioEndpointVolume.SetMasterVolumeLevelScalar(VolumeMixer/100, ByVal %NULL)
                      Case  0
                         If Mute Then pIAudioEndpointVolume.SetMute(Mute, ByVal %NULL)
                      Case +1
                         If VolumeMixer = 100 Then Beep
                         VolumeMixer = Min(100,VolumeMixer+5)
                         pIAudioEndpointVolume.SetMasterVolumeLevelScalar(VolumeMixer/100, ByVal %NULL)
                   End Select

               End If
           End If
       End If
       pIMMDeviceEnumerator  = Nothing
       pIMMDevice            = Nothing
       pIAudioEndpointVolume = Nothing
       Statusbar Set Text hDlg, %IDC_Statusbar, 3,0, IIf$(Mute, "Mute: On", "Volume: " + Format$(VolumeMixer * 100, "#0.0") + "%")
   End If
End Sub

Sub CreateStatusBar
   Control Add Statusbar, hDlg, %IDC_Statusbar, "", 0,0,0,0
   Statusbar Set Parts hDlg, %IDC_StatusBar, 80, 44, 9999
End Sub

Sub CreateListView
   Control Add ListView, hDlg, %IDC_ListView, "", 5,60,175,75, %WS_TabStop Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_ListView To hListView

   ListView Insert Column hDlg, %IDC_ListView, 1, "Song Name", 435, 0
   ListView Insert Column hDlg, %IDC_ListView, 2, "Song Path", 9999, 0
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect Or %LVS_Ex_CheckBoxes

   Menu New PopUp To hContext
   Menu Add String, hContext, "Clear List", %IDM_RemoveAll, %MF_Enabled
   Menu Add String, hContext, "Remove Selected Song", %IDM_Remove, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Play", %IDM_Play, %MF_Enabled
   Menu Add String, hContext, "Pause", %IDM_Pause, %MF_Enabled
   Menu Add String, hContext, "Stop", %IDM_Stop, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Play Next", %IDM_Next, %MF_Enabled
   Menu Add String, hContext, "Play Previous", %IDM_Previous, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Check All", %IDM_CheckAll, %MF_Enabled
   Menu Add String, hContext, "UnCheck All", %IDM_UnCheckAll, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Go To Song Playing", %IDM_GoToSongPlaying, %MF_Enabled
   Menu Add String, hContext, "Reload PlayList", %IDM_Reload, %MF_Enabled
   Menu Add String, hContext, "Remove Duplicates", %IDM_RemoveDupes, %MF_Enabled
   Menu Add String, hContext, "Open Song Location", %IDM_Open, %MF_Enabled

   'create imagelist
   ImageList New Icon 16,16,24,3 To hImageList
   ImageList Add Icon hImageList, "xup"
   ImageList Add Icon hImageList, "xdown"

   'assign imagelist to header
   hHeader = ListView_GetHeader(hListView)
   Header_SetImageList hHeader, hImagelist


End Sub

Sub PlayCurrentSong
   Local temp$
   Local pIMediaEventEx As IMediaEventEx
   ListView Get Select hDlg, %IDC_ListView To CurrentSong
   If CurrentSong = 0 Then Beep : Exit Sub

   ListView Get Text hDlg, %IDC_ListView, CurrentSong, 2 To temp$
   If IsFile(temp$) Then
      If InStr(FileExt,LCase$(Right$(temp$,4))) Then
         pAfxMp3.Load(temp$)
         pIMediaEventEx = pAfxMp3.GetIMediaEventExObject
         pIMediaEventEx.SetNotifyWindow(hDlg, %WM_GRAPHNOTIFY, 0)
         pIMediaEventEx = Nothing
         SongLength = pAfxMp3.Duration / 10000000
         Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, $Spc + Format$(SongLength/60,"#0") + ":" + Format$(SongLength Mod 60,"00")
         Statusbar Set Text hDlg, %IDC_StatusBar, 3, 0, PathName$(Namex,temp$)
         pAfxMp3.Run
      End If
   Else
      Beep
   End If
   SongPlaying = CurrentSong
End Sub

Sub SetHeaderIconsOnRight(ByVal iActiveColumn As Integer)
   Local i As Integer, hdi As HD_ITEM
   For i = 0 To Header_GetItemCount(hHeader) - 1
      hdi.mask = %HDI_FORMAT Or %HDI_IMAGE
      hdi.fmt = %HDF_String Or %HDF_Image Or %HDF_Bitmap_On_Right
      If i = iActiveColumn Then hdi.iImage = SortDirection Else hdi.iImage = 3
      Header_SetItem(hHeader, i, hdi)
   Next
End Sub

Sub SelectAll(Flag As Long)
   Local i As Long
   ListView Get Count hDlg, %IDC_ListView To SongCount
   For i = 0 To SongCount-1
      ListView_SetCheckState hListView, i, Flag
   Next i
End Sub

Sub OpenPlayList
   Local temp$, iCount,iChecked As Long
   ListView Reset hDlg, %IDC_ListView
   Open PlayList For Input As #1

   Line Input #1, temp$
   If temp$ <> "gbPlayer PlayList" Then
      Beep
      Statusbar Set Text hDlg, %IDC_StatusBar, 3, 0, "Invalid gbPlayer Play List"
      Exit Sub
   End If

   While IsFalse Eof(1)
      Line Input #1, temp$
      iChecked = Val(Left$(temp$,1))
      temp$ = Mid$(temp$,2)
      Incr iCount
      ListView Insert Item hDlg, %IDC_ListView, iCount, 0,  PathName$(Namex,temp$)
      ListView Set Text hDlg, %IDC_ListView, iCount, 2, temp$
      ListView_SetCheckState hListView, iCount-1,iChecked
   Wend
   Close #1
   ListView Get Count hDlg, %IDC_ListView To SongCount
   Dialog Set Text hDlg, "gbPlayer  v" + $ver + Space$(5) + PlayList
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0,"Songs:" + Str$(SongCount)
End Sub

Sub SavePlayList
   Local i,iChecked As Long, temp$
   ListView Get Count hDlg, %IDC_ListView To SongCount
   Open PlayList For Output As #1
   Print #1, "gbPlayer PlayList"
   For i=1 To SongCount
      ListView Get Text hDlg, %IDC_ListView, i, 2 To temp$
      iChecked = ListView_GetCheckState(hListView, i-1)
      Print #1, IIf$(iChecked,"1","0") + temp$
   Next i
   Close #1
   Dialog Set Text hDlg, "gbPlayer  v" + $ver + Space$(5) + PlayList
End Sub

Sub RemoveDupes
   Local i,iResult As Long, temp$
   ListView Get Count hDlg, %IDC_ListView To SongCount
   For i = 1 To SongCount
      ListView Get Text hDlg, %IDC_ListView, i,1 To temp$
      ListView Find Exact hDlg, %IDC_ListView, i+1, temp$ To iResult
      While iResult
         ListView Delete Item hDlg, %IDC_ListView, iResult
         ListView Find Exact hDlg, %IDC_ListView, i+1, temp$ To iResult
      Wend
      ListView Get Count hDlg, %IDC_ListView To SongCount
   Next i
   ListView Get Count hDlg, %IDC_ListView To SongCount
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0,"Songs:" + Str$(SongCount)
   CurrentSong = 1
   ListView Select hDlg, %IDC_ListView, CurrentSong
   ListView Visible hDlg, %IDC_ListView, CurrentSong
   ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
End Sub

Sub AddFilesFromCommand
   Local iCount As Long, temp$
   temp$ = Command$(iCount)
   While Len(temp$)
      If IsFile(temp$) Then
         ListView Insert Item hDlg, %IDC_ListView, 1, 0,  PathName$(Namex,temp$)
         ListView Set Text hDlg, %IDC_ListView, 1, 2, temp$
         Incr iCount
      ElseIf IsFolder(temp$) Then
         If SubFolders Then
            AddFilesFromSubFolders((temp$),iCount)
         Else
            AddFilesFromFolder((temp$),iCount)
         End If
      Else
         Exit Loop
      End If
      temp$ = Command$(iCount)
   Wend
   If iCount Then CurrentSong = 1
End Sub

Sub AddFilesFromSubFolders(Folder As String, FileCount As Long)
   Local iPos,FolderCount As Long, tempDIR As DirData, temp$, fSpec$
   Dim Folders(100000) As DirData

   fSpec$ = Trim$(Folder,"\")
   Replace "." With "*." In fSpec$

   Folders(iPos).FileName = fSpec$    'no ending \
   Do While Len(Folders(iPos).FileName)
      temp$ = Dir$(Folders(iPos).FileName + "\*.*", %Normal + %SubDir, To tempDir)
      Do While Len(temp$)
         tempDir.FileName = Folders(iPos).FileName + "\" + tempDir.FileName
         If (tempDir.FileAttributes And %File_Attribute_Directory) = 0 Then  'file
            If InStr(FileExt,LCase$(Right$(tempDir.FileName,4))) Then
               'file type of interest, put in Play List
               Incr FileCount
               ListView Insert Item hDlg, %IDC_ListView, 1, 0,  PathName$(Namex,tempDir.FileName)
               ListView Set Text hDlg, %IDC_ListView, 1, 2, tempDir.FileName
            End If
         Else                                                                'folder
            Incr FolderCount
            If FolderCount >= UBound(Folders) Then ReDim Preserve Folders(UBound(Folders)+5000)
            Folders(FolderCount) = tempDir
         End If
         temp$ = Dir$(Next, To tempDir)
      Loop
      Incr iPos
   Loop
   If FileCount Then CurrentSong = 1
End Sub


Sub AddFilesFromFolder(Folder As String, FileCount As Long)
   Local temp$
   temp$ = Dir$(Folder + "\*.*")
   While Len(temp$)
      If InStr(FileExt,Right$(temp$,4)) Then
         ListView Insert Item hDlg, %IDC_ListView, 1, 0, temp$
         ListView Set Text hDlg, %IDC_ListView, 1, 2, Folder + "\" + temp$
      End If
      Incr FileCount
      temp$ = Dir$(Next)
   Wend
   If FileCount Then CurrentSong = 1
End Sub


Function CheckCount() As Long
   Local i,iChecked,iCount As Long
   ListView Get Count hDlg, %IDC_ListView To SongCount
   For i = 1 To SongCount
      iChecked = ListView_GetCheckState(hListView, i-1)
      If iChecked Then Incr iCount
   Next i
   Function = iCount
End Function

Sub PlayPreviousSong
   ListView Get Count hDlg, %IDC_ListView To SongCount
   If SongCount = 0 Then Beep : Exit Sub
   ListView Get Select hDlg, %IDC_ListView To CurrentSong
   If CurrentSong = 1 Then Beep : Exit Sub

   Decr CurrentSong
   ListView Select hDlg, %IDC_ListView, CurrentSong
   ListView Visible hDlg, %IDC_ListView, CurrentSong
   ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
   PlayCurrentSong
End Sub

Sub PlayPreviousCheckedSong
   Local i,iChecked As Long
   ListView Get Count hDlg, %IDC_ListView To SongCount
   If SongCount = 0 Then Beep : Exit Sub
   ListView Get Select hDlg, %IDC_ListView To CurrentSong
   If CurrentSong = 1 Then Beep : Exit Sub

   For i = CurrentSong-1 To 1 Step -1
      iChecked = ListView_GetCheckState(hListView, i-1)
      If iChecked Then
         CurrentSong = i
         ListView Select hDlg, %IDC_ListView, CurrentSong
         ListView Visible hDlg, %IDC_ListView, CurrentSong
         ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
         PlayCurrentSong
         Exit Sub
      End If
   Next i
End Sub

Sub PlayNextSong
   ListView Get Count hDlg, %IDC_ListView To SongCount
   If SongCount = 0 Then Beep : Exit Sub
   ListView Get Select hDlg, %IDC_ListView To CurrentSong
   If CurrentSong = SongCount Then Beep : Exit Sub

   Incr CurrentSong
   ListView Select hDlg, %IDC_ListView, CurrentSong
   ListView Visible hDlg, %IDC_ListView, CurrentSong
   ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
   PlayCurrentSong
End Sub

Sub PlayNextCheckedSong
   Local i,iChecked As Long
   ListView Get Count hDlg, %IDC_ListView To SongCount
   If SongCount = 0 Then Beep : Exit Sub
   ListView Get Select hDlg, %IDC_ListView To CurrentSong
   If CurrentSong = SongCount Then Beep : Exit Sub

   ListView Get Select hDlg, %IDC_ListView To CurrentSong
   For i = CurrentSong+1 To songCount
      iChecked = ListView_GetCheckState(hListView, i-1)
      If iChecked Then
         CurrentSong = i
         ListView Select hDlg, %IDC_ListView, CurrentSong
         ListView Visible hDlg, %IDC_ListView, CurrentSong
         ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
         PlayCurrentSong
         Exit Sub
      End If
   Next i
End Sub

Sub PlayNextSongLooping
   ListView Get Count hDlg, %IDC_ListView To SongCount
   If SongCount = 0 Then Exit Sub

   ListView Get Select hDlg, %IDC_ListView To CurrentSong
   ListView Get Count hDlg, %IDC_ListView To SongCount
   Incr CurrentSong
   If CurrentSong > SongCount Then CurrentSong = 1
   ListView Select hDlg, %IDC_ListView, CurrentSong
   ListView Visible hDlg, %IDC_ListView, CurrentSong
   ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
   PlayCurrentSong
End Sub

Sub PlayNextCheckedSongLooping
   Local i,iChecked As Long
   ListView Get Count hDlg, %IDC_ListView To SongCount
   If SongCount = 0 Then Exit Sub

   ListView Get Select hDlg, %IDC_ListView To CurrentSong
   For i = CurrentSong+1 To songCount
      iChecked = ListView_GetCheckState(hListView, i-1)
      If iChecked Then
         CurrentSong = i
         ListView Select hDlg, %IDC_ListView, CurrentSong
         ListView Visible hDlg, %IDC_ListView, CurrentSong
         ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
         PlayCurrentSong
         Exit Sub
      End If
   Next i
   For i = 1 To CurrentSong
      iChecked = ListView_GetCheckState(hListView, i-1)
      If iChecked Then
         CurrentSong = i
         ListView Select hDlg, %IDC_ListView, CurrentSong
         ListView Visible hDlg, %IDC_ListView, CurrentSong
         ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
         PlayCurrentSong
         Exit Sub
      End If
   Next i
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(7)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDT_Help   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_G  : ac(c).cmd   = %IDM_GoToSongPlaying  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_M  : ac(c).cmd   = %IDT_SoundBlock   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N  : ac(c).cmd   = %IDM_Next   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P  : ac(c).cmd   = %IDM_Previous : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S  : ac(c).cmd   = %IDM_MiniBar : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_X  : ac(c).cmd   = %IDM_Remove : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z  : ac(c).cmd   = %IDM_Compact : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function SelectAndOpenPlayList As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "PlayList (*.txt)" + $Nul + "*.txt" + $Nul
    startfolder$ = IIf$(IsFile(PlayList), PlayList, Exe.Path$)     'initial folder to be displayed
    startfile$ = (PlayList)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       PlayList = filevar$
       OpenPlayList

       ListView Get Count hDlg, %IDC_ListView To SongCount
       If SongCount Then CurrentSong = 1
       ListView Select hDlg, %IDC_ListView, CurrentSong
       ListView Visible hDlg, %IDC_ListView, CurrentSong
       ListView_SetItemState hListView, CurrentSong-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
       If AutoPlay Then PlayCurrentSong
    End If
End Function

Function SaveAsPlayList() As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "Play List (*.txt)" + $Nul + "*.txt" + $Nul
    startfolder$ = IIf$(IsFile(PlayList), PathName$(Path,PlayList), Exe.Path$)     'initial folder to be displayed
    startfile$ = (PlayList)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_PathMustExist Or %OFN_OverWritePrompt
    defaultext$ = "txt"
    Display Savefile hDlg, 100, 100, "Save Play List to File", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       PlayList = filevar$
       SavePlayList
    End If
End Function

Function FileExt() As String
   Local temp$
   If UseWMA Then temp$ += ".wma"
   If UseWAV Then temp$ += ".wav"
   If UseMP3 Then temp$ += ".mp3"
   If UseWMA Then temp$ += OtherExt
   Function = temp$
End Function

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 120  : @cst.cx = 60           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 100 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub SetOtherExtensions
   Local x,y As Long, temp$
   Dialog Get Loc hDlg To x,y
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Additional File Extensions", OtherExt, x+100,y+100)
   UnhookWindowsHookEx ghHook
   If Len(temp$) Then OtherExt = temp$
End Sub
